package io.hmit.common.utils;

import org.apache.commons.lang3.StringUtils;
import org.joda.time.DateTime;
import org.joda.time.LocalDate;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 日期处理
 *
 * @author zsh 408538940@qq.com
 */
public class DateUtils {

    /**
     * 时间格式(yyyy-MM-dd)
     */
    public final static String DATE_PATTERN = "yyyy-MM-dd";
    /**
     * 时间格式(HH:mm)
     */
    public final static String HOUR_PATTERN = "HH:mm";
    /**
     * 时间格式(yyyy-MM-dd HH:mm:ss)
     */
    public final static String DATE_TIME_PATTERN = "yyyy-MM-dd HH:mm:ss";

    /**
     * 日期格式化 日期格式为：yyyy-MM-dd
     *
     * @param date 日期
     * @return 返回yyyy-MM-dd格式日期
     */
    public static String format(Date date) {
        return format(date, DATE_PATTERN);
    }

    /**
     * 日期格式化 日期格式为：yyyy-MM-dd
     *
     * @param date    日期
     * @param pattern 格式，如：DateUtils.DATE_TIME_PATTERN
     * @return 返回yyyy-MM-dd格式日期
     */
    public static String format(Date date, String pattern) {

        if (date != null) {
            SimpleDateFormat df = new SimpleDateFormat(pattern);
            return df.format(date);
        }
        return null;
    }

    /**
     * 日期解析
     *
     * @param date    日期
     * @param pattern 格式，如：DateUtils.DATE_TIME_PATTERN
     * @return 返回Date
     */
    public static Date parse(String date, String pattern) {

        try {
            return new SimpleDateFormat(pattern).parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 字符串转换成日期
     *
     * @param strDate 日期字符串
     * @param pattern 日期的格式，如：DateUtils.DATE_TIME_PATTERN
     */
    public static Date stringToDate(String strDate, String pattern) {

        if (StringUtils.isBlank(strDate)) {
            return null;
        }

        DateTimeFormatter fmt = DateTimeFormat.forPattern(pattern);
        return fmt.parseLocalDateTime(strDate).toDate();
    }

    /**
     * 根据周数，获取开始日期、结束日期
     *
     * @param week 周期  0本周，-1上周，-2上上周，1下周，2下下周
     * @return 返回date[0]开始日期、date[1]结束日期
     */
    public static Date[] getWeekStartAndEnd(int week) {

        DateTime dateTime = new DateTime();
        LocalDate date = new LocalDate(dateTime.plusWeeks(week));

        date = date.dayOfWeek().withMinimumValue();
        Date beginDate = date.toDate();
        Date endDate = date.plusDays(6).toDate();
        return new Date[]{beginDate, endDate};
    }

    /**
     * 对日期的【秒】进行加/减
     *
     * @param date    日期
     * @param seconds 秒数，负数为减
     * @return 加/减几秒后的日期
     */
    public static Date addDateSeconds(Date date, int seconds) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusSeconds(seconds).toDate();
    }

    /**
     * 对日期的【分钟】进行加/减
     *
     * @param date    日期
     * @param minutes 分钟数，负数为减
     * @return 加/减几分钟后的日期
     */
    public static Date addDateMinutes(Date date, int minutes) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusMinutes(minutes).toDate();
    }

    /**
     * 对日期的【小时】进行加/减
     *
     * @param date  日期
     * @param hours 小时数，负数为减
     * @return 加/减几小时后的日期
     */
    public static Date addDateHours(Date date, int hours) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusHours(hours).toDate();
    }

    /**
     * 对日期的【天】进行加/减
     *
     * @param date 日期
     * @param days 天数，负数为减
     * @return 加/减几天后的日期
     */
    public static Date addDateDays(Date date, int days) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusDays(days).toDate();
    }

    /**
     * 对日期的【周】进行加/减
     *
     * @param date  日期
     * @param weeks 周数，负数为减
     * @return 加/减几周后的日期
     */
    public static Date addDateWeeks(Date date, int weeks) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusWeeks(weeks).toDate();
    }

    /**
     * 对日期的【月】进行加/减
     *
     * @param date   日期
     * @param months 月数，负数为减
     * @return 加/减几月后的日期
     */
    public static Date addDateMonths(Date date, int months) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusMonths(months).toDate();
    }

    /**
     * 对日期的【年】进行加/减
     *
     * @param date  日期
     * @param years 年数，负数为减
     * @return 加/减几年后的日期
     */
    public static Date addDateYears(Date date, int years) {

        DateTime dateTime = new DateTime(date);
        return dateTime.plusYears(years).toDate();
    }

    public static String getCurrentTimes() {
        Calendar c = Calendar.getInstance();//可以对每个时间域单独修改




        int year = c.get(Calendar.YEAR);
        int month = c.get(Calendar.MONTH) +1;
        int date = c.get(Calendar.DATE);
        int hour = c.get(Calendar.HOUR_OF_DAY);
        int minute = c.get(Calendar.MINUTE);
        int second = c.get(Calendar.SECOND);

        String year1 = String.valueOf(year);
        if (year<10){
            year1 = "0"+year1;
        }
        String month1 = String.valueOf(month);
        if (month<10){
            month1 = "0"+month1;
        }
        String date1 = String.valueOf(date);
        if (date<10){
            date1 = "0"+date1;
        }
        String hour1 = String.valueOf(hour);
        if (hour<10){
            hour1 = "0"+hour1;
        }
        String minute1 = String.valueOf(minute);
        if (minute<10){
            minute1 = "0"+minute1;
        }
        String second1 = String.valueOf(second);
        if (second<10){
            second1 = "0"+second1;
        }
        return year1  +  month1 + date1 +hour1  +minute1  + second1;
    }


    /**
     * 将一段时间段拆分成子区间 按照时间间隔拆分
     *
     * @param startTime 开始时间
     * @param endTime 结束时间
     * @param period 时间间隔 单位：分钟
     * @return 按时间间隔划分的子时间区间List
     * @throws ParseException
     */
    public static List<String> getTimePeriod(String startTime, String endTime, String period) throws ParseException {
        SimpleDateFormat sf = new SimpleDateFormat("HH:mm");
        List<String> timeList = new ArrayList<>();
        while(startTime.compareTo(endTime)<0){
            Calendar c = Calendar.getInstance();
            c.setTime(sf.parse(startTime));
            long sec=c.getTimeInMillis();
            sec += Integer.parseInt(period) * 60 * 1000;
            Date data = new Date(sec);
            String time21 = sf.format(data);
            if(time21.compareTo(endTime)>0){
                time21 = endTime;
            }
            System.out.println(startTime+"-"+time21);
            timeList.add(startTime+"-"+time21);
            startTime = time21;
        }

        return timeList;
    }

    /**
     * 将预约时间格式拆分，比较时间大小并返回
     *
     * @param times 开始时间 传入的时间格式：2021-02-02 08:30-09:00
     * @return 当前时间是否大于传入的时间
     * @throws ParseException
     */
    public static boolean compareTime(String times) throws ParseException {

        String [] time = times.split(" ");
        String now = format(new Date());
        if(now.compareTo(time[0])>0){
            System.out.println("当前时间："+now+" > 传入时间："+time[0]);
            return true;
        }

        if(now.compareTo(time[0]) == 0){
            String hour = format(new Date(),HOUR_PATTERN);
            String [] hours = time[1].split("-");
            if(hour.compareTo(hours[1]) >0 ){
                System.out.println("当前小时："+hour+" > 传入小时："+ hours[1]);
            }
            return true;
        }
        return false;

    }

}
